import alsaaudio

from osd import *

class Alsa(Osd):
    def __init__(self, config):
        Osd.__init__(self, config)
        
        self._config = config
        self._mixer = alsaaudio.Mixer()
    
    def set_volume(self, value):
        value = int(value)
        self._mixer.setvolume(value)
        self.notify("Volume %i%%" % value)

    
    def get_volume(self):
        return self._mixer.getvolume()[0]
    
    def volume(self, step):
        v = self.get_volume()
        new_v = v + int(step)
        if new_v > 100:
            new_v = 100
        elif new_v < 0:
            new_v = 0
        self.set_volume(new_v)
    
    def mute(self):
        if self._mixer.getmute()[0]:
            self._mixer.setmute(False)
            self.notify("Volume unmute")
        else:
            self._mixer.setmute(True)
            self.notify("Volume mute")
